/************************************************************************
MakePDF.c  v 0.07 alpha 08.03.99
please report any bug to: klee@informatik.unibw-muenchen.de
*************************************************************************
external functions used:  getc(); putc(); fopen(); fclose();
*************************************************************************
should compile with any C compiler with int >= 32 bit
************************************************************************/
/*
v 0.03 17.6.97
v 0.04  8.6.97 : gif support
       21.8.97 : error in get_dec
v 0.05 10.10.97: StandardEncoding for ZapfDingbats + Symbol
v 0.06 21.10.97: para[para_pos++]=para[para_pos-2]+get_dec();
                   replaced by
                 para[para_pos]=para[para_pos-2]+get_dec(); para_pos++;
                 (differnet behaviour on DOS+Linux and SUN gcc) 
       25.02.98: error messages modified
       07.08.98: datin=getnext(tmp)+ (getnext(tmp)<<8) +(getnext(tmp)<<16);
                 replaced by: datin = getnext(); 
                              datin += (getnext()<<8); 
                              datin += (getnext()<<16);
v 0.07 08.03.99: getch() modified (pex file can now be DOS format on UNIX
                                   systems)
                 insert_gif() some cosmetic changes
*/
 
#include <stdio.h>

#ifndef NULL
#define NULL 0
#endif 

#define TXT_COMMAND_BEGIN 256
#define TXT_COMMAND_END  257
#define PDF_COMMAND_BEGIN 258
#define PDF_COMMAND_END  259
#define CTR_COMMAND_BEGIN 260
#define CTR_COMMAND_END  261

#define PARENT 300  /* page tree tiefe */

#define max_obj 30000
#define max_page 10000
#define max_pict 256
#define max_sound 16
#define max_pdfcmd 1024
#define max_inittext 1024
#define max_annot 256
#define max_outline 10000
#define max_text 100000
#define max_para 5000
#define max_string 256
#define max_outline_level 10

FILE *pex, *pdf, *fopen(), *fopenb();
int pdf_pos=0, stream_start, pex_eof=0;
int last_char, this_char, next_char, last_put=0;
int line_nr=1;
int in_ctr_cmd=0;

int obj_pos=1, obj[max_obj+5];
int page_pos=0, page[max_page+5], parent[max_page/PARENT+5];
int pict[max_pict+5], pict_onpage[max_pict+5];
int sound[max_sound+5];
int pdfcmd_pos=0; char pdfcmd[max_pdfcmd+5];
int inittext_done=0; char inittext[max_inittext+5];
int inpage=0, intext=0, instring=0, text_onpage=0;
int line_count=0, line_max=0;
int paper_x=595, paper_y=842; /* A4= 595,842  LETTER= 612,792 */

int annot_pos=0; int annot[max_annot+5]; 
int outline_pos=0; 
    struct {unsigned int level,page,text;} outline[max_outline+5];

int text_pos=0; char text[max_text+5];
int para_pos=0; int  para[max_para+5+100];
int first_annot_onpage=0, annot_onpage=0, action_onpage=0 ;

/***********************************************************************/

main(nargs,args) int nargs; char *args[];
{if (nargs!=3) ende(1,1);
 pex = fopen(args[1],"r");  if (pex==NULL) ende(2,2); getcha();
 pdf = fopen(args[2],"wb"); if (pdf==NULL) ende(3,3);

 out_header();
 out_body();
 out_crossref();
 out_trailer();

 ende(4,0);
}

/***********************************************************************/
int out_header()
{out_string("%PDF-1.2\n%\210\211\212 This is a binary file. Don't edit.\n\
%created by MakePDF V 0.07 alpha\n\
%ftp://mistress.informatik.unibw-muenchen.de/pub/pdf/\n");
}
/***********************************************************************/
int out_crossref()
{int i;
 obj[0]=pdf_pos;
 out_string("xref\n0 ");
 out_dec(obj_pos);
 out_string("\n0000000000 65535 f\n");
 for (i=1; i<obj_pos; i++) 
    {out_dec10(obj[i]); out_string(" 00000 n\n");}
}
/***********************************************************************/
int out_trailer()
{out_string("trailer\n<<\n/Size ");
 out_dec(obj_pos);
 out_string("\n/Root 1 0 R\n/Info 7 0 R\n>>\nstartxref\n");
 out_dec(obj[0]);
 out_string("\n%%EOF\n");
}
/***********************************************************************/
int out_body()
{int i;
 out_body_head();
 while (!pex_eof) {if (!(page_pos%PARENT))parent[page_pos/PARENT]=obj_pos++;
                   out_page_contents(); out_page();}
 out_body_tail();
}
/***********************************************************************/
int out_body_head()
{obj_pos=8; 
 out_obj("<<\n/F1 9 0 R\n/F2 10 0 R\n/F3 11 0 R\n/F4 12 0 R\n\
/F5 13 0 R\n/F6 14 0 R\n/F7 15 0 R\n/F8 16 0 R\n/F9 17 0 R\n\
/F10 18 0 R\n/F11 19 0 R\n/F12 20 0 R\n/F13 21 0 R\n/F14 22 0 R\n>>");

 out_obj("<<\n/Type /Font\n/Subtype /Type1\n/Name /F1\n/BaseFont \
/Courier\n/Encoding /WinAnsiEncoding\n>>");
 out_obj("<<\n/Type /Font\n/Subtype /Type1\n/Name /F2\n/BaseFont \
/Courier-Bold\n/Encoding /WinAnsiEncoding\n>>");
 out_obj("<<\n/Type /Font\n/Subtype /Type1\n/Name /F3\n/BaseFont \
/Courier-Oblique\n/Encoding /WinAnsiEncoding\n>>");
 out_obj("<<\n/Type /Font\n/Subtype /Type1\n/Name /F4\n/BaseFont \
/Courier-BoldOblique\n/Encoding /WinAnsiEncoding\n>>");
 out_obj("<<\n/Type /Font\n/Subtype /Type1\n/Name /F5\n/BaseFont \
/Helvetica\n/Encoding /WinAnsiEncoding\n>>");
 out_obj("<<\n/Type /Font\n/Subtype /Type1\n/Name /F6\n/BaseFont \
/Helvetica-Bold\n/Encoding /WinAnsiEncoding\n>>");
 out_obj("<<\n/Type /Font\n/Subtype /Type1\n/Name /F7\n/BaseFont \
/Helvetica-Oblique\n/Encoding /WinAnsiEncoding\n>>");
 out_obj("<<\n/Type /Font\n/Subtype /Type1\n/Name /F8\n/BaseFont \
/Helvetica-BoldOblique\n/Encoding /WinAnsiEncoding\n>>");
 out_obj("<<\n/Type /Font\n/Subtype /Type1\n/Name /F9\n/BaseFont \
/Symbol\n>>");
 out_obj("<<\n/Type /Font\n/Subtype /Type1\n/Name /F10\n/BaseFont \
/Times-Roman\n/Encoding /WinAnsiEncoding\n>>");
 out_obj("<<\n/Type /Font\n/Subtype /Type1\n/Name /F11\n/BaseFont \
/Times-Bold\n/Encoding /WinAnsiEncoding\n>>");
 out_obj("<<\n/Type /Font\n/Subtype /Type1\n/Name /F12\n/BaseFont \
/Times-Italic\n/Encoding /WinAnsiEncoding\n>>");
 out_obj("<<\n/Type /Font\n/Subtype /Type1\n/Name /F13\n/BaseFont \
/Times-BoldItalic\n/Encoding /WinAnsiEncoding\n>>");
 out_obj("<<\n/Type /Font\n/Subtype /Type1\n/Name /F14\n/BaseFont \
/ZapfDingbats\n>>");
}

/***********************************************************************/

int out_body_tail()
{int objsav,ostart,i,j,k,l,m,n,o,p;
 int oparent[max_outline_level+5];
 int oprevious[max_outline_level+5];
 
 oparent[1]=2;
 oprevious[1]=0;
 outline[outline_pos].level=0;
 
 ostart=obj_pos;
 for (i=0; i<outline_pos; i++)
   {j=outline[i].page; k=outline[i].text; l=outline[i].level;
    if (j>page_pos || j<=0) ende(5,4);
    out_obj_head("<<\n/Parent ");
    out_dec(oparent[l]); out_string(" 0 R\n/Dest [");
    out_dec(page[j-1]); out_string(" 0 R /XYZ null ");
    out_dec(paper_y); out_string(" null]\n/Title (");
    while (text[k]) out_byte(text[k++]);
    out_string(")\n");
    if (oprevious[l]) 
       {out_string("/Prev "); out_dec(oprevious[l]); 
        out_string(" 0 R\n");
       }
    oprevious[l]=ostart+i;
    o=0; n=0;
    for (m=i+1; m<outline_pos; m++) 
        {if ( (n=outline[m].level) == (l+1) ) {o++; p=m;}
         if (n<=l) break;
        }
    if (n==l) 
       {out_string("/Next "); out_dec(ostart+m); out_string(" 0 R\n");}
    if (o)
       {out_string("/First "); out_dec(ostart+i+1); 
        out_string(" 0 R\n/Last "); out_dec(ostart+p);
        out_string(" 0 R\n/Count "); out_dec(-o); out_string("\n");
        oparent[l+1]=ostart+i;
        oprevious[l+1]=0;
       }
    out_string(">>\nendobj\n");
   }

 objsav=obj_pos;

 for (i=0; i<annot_pos; i++)
   {n=annot[i]; 
    j=para[n++];
    obj_pos=para[n++];
    out_obj_head("<<\n/Type /Annot\n/Subtype /");

    if (j) out_string("Link"); else out_string("Text");
    out_string("\n/Rect [");
    out_dec(para[n++]); out_byte(' ');
    out_dec(para[n++]); out_byte(' ');
    out_dec(para[n++]); out_byte(' ');
    out_dec(para[n++]); out_string("]\n"); 
    if (j) {out_string("/Border [0 0 "); out_dec(para[n++]);
            out_string("]\n/C [1 0 0.5]\n");}

    k=para[n++];

    if (j==0)   /* text annot */
       {out_string("/Contents (");
        while (text[k]) out_byte(text[k++]);
        out_string(")\n>>\nendobj\n");
       }

    else if (j==1) /* destination annot */
       {if (k>page_pos || k<=0) ende(6,4);
        out_string("/Dest ["); out_dec(page[k-1]); 
        out_string(" 0 R /XYZ null ");
        out_dec(paper_y); out_string(" null]\n>>\nendobj\n");
       }
       
    else if (j==2) /* action annot */
       {
        out_string("/A ");
        out_dec(obj_pos); 
        out_string(" 0 R \n>>\nendobj\n");
        
        o=para[n++];
        for (l=1; l<=o; l++)
          {m=para[n++];
           if (m==1) /*url*/
            {out_obj_head("<<\n/Type /Action /S /URI\n");
             if (l!=o) 
               {out_string("/Next ");
                out_dec(obj_pos);
                out_string(" 0 R\n");
               }
             out_string("/URI (");
             while (text[k]) out_byte(text[k++]); k++;
             out_string(")\n>>\nendobj\n");
            }
            
           else if (m==2) /*exec*/
            {out_obj_head("<<\n/Type /Action /S /Launch\n");
             if (l!=o) 
               {out_string("/Next ");
                out_dec(obj_pos);
                out_string(" 0 R\n");
               }
             out_string("/Win <</F (");
             while (text[k]) out_byte(text[k++]); k++;
             out_string(")");
             if (text[k])
               {out_string(" /P (");
                while (text[k]) out_byte(text[k++]);
                out_string(")");
               } 
             k++;
             out_string(">>\n>>\nendobj\n");
            }
           else if (m==3) /*sound*/
            {out_obj_head("<<\n/Type /Action /S /Sound /Synchronous true \n");
             if (l!=o) 
               {out_string("/Next ");
                out_dec(obj_pos);
                out_string(" 0 R\n");
               }
             out_string("/Sound ");
             out_dec(sound[para[n++]]);
             out_string(" 0 R\n>>\nendobj\n");
            }
           else if (m==4) /*goto*/
            {out_obj_head("<<\n/Type /Action /S /GoTo\n");
             if (l!=o) 
               {out_string("/Next ");
                out_dec(obj_pos);
                out_string(" 0 R\n");
               }
             m=para[n++];
             if (m>page_pos || m<=0) ende(7,4);
             out_string("/D ["); out_dec(page[m-1]); 
             out_string(" 0 R /FitR "); out_dec(para[n++]); 
             out_string(" "); out_dec(para[n++]); 
             out_string(" "); out_dec(para[n++]); 
             out_string(" "); out_dec(para[n++]); 
             out_string(" ]\n>>\nendobj\n");
            }
           else if (m==5) /*first*/
            {out_obj_head("<<\n/Type /Action /S /Named /N /FirstPage \n");
             if (l!=o) 
               {out_string("/Next ");
                out_dec(obj_pos);
                out_string(" 0 R\n");
               }
             out_string("\n>>\nendobj\n");
            }
           else if (m==6) /*prev*/
            {out_obj_head("<<\n/Type /Action /S /Named /N /PrevPage \n");
             if (l!=o) 
               {out_string("/Next ");
                out_dec(obj_pos);
                out_string(" 0 R\n");
               }
             out_string("\n>>\nendobj\n");
            }
           else if (m==7) /*next*/
            {out_obj_head("<<\n/Type /Action /S /Named /N /NextPage \n");
             if (l!=o) 
               {out_string("/Next ");
                out_dec(obj_pos);
                out_string(" 0 R\n");
               }
             out_string("\n>>\nendobj\n");
            }
           else if (m==8) /*last*/
            {out_obj_head("<<\n/Type /Action /S /Named /N /LastPage \n");
             if (l!=o) 
               {out_string("/Next ");
                out_dec(obj_pos);
                out_string(" 0 R\n");
               }
             out_string("\n>>\nendobj\n");
            }
           else if (m==9) /*back*/
            {out_obj_head("<<\n/Type /Action /S /Named /N /GoBack\n");
             if (l!=o) 
               {out_string("/Next ");
                out_dec(obj_pos);
                out_string(" 0 R\n");
               }
             out_string("\n>>\nendobj\n");
            }
           else if (m==10) /*forward*/
            {out_obj_head("<<\n/Type /Action /S /Named /N /GoForward \n");
             if (l!=o) 
               {out_string("/Next ");
                out_dec(obj_pos);
                out_string(" 0 R\n");
               }
             out_string("\n>>\nendobj\n");
            }
            
          } 
       }

   }


 obj_pos=1;
 out_obj_head("<<\n/Type /Catalog\n/Outlines 2 0 R\n/Pages 3 0 R\n");
 if (outline_pos) out_string("/PageMode /UseOutlines\n");
 out_string("/OpenAction 4 0 R\n/ViewerPreferences 5 0 R\n>>\nendobj\n");

 out_obj_head("<<\n/Type /Outlines\n/Count ");
 j=0; for (i=0; i<outline_pos; i++) if (outline[i].level==1) {j++; k=i;}
 out_dec(j);
 if (outline_pos) 
   {out_string("\n/First "); out_dec(ostart); out_string(" 0 R\n/Last "); 
    out_dec(ostart+k); out_string(" 0 R");
   }
 out_string("\n>>\nendobj\n");

 out_obj_head("<<\n/Type /Pages\n/Count ");
 out_dec(page_pos);
 out_string("\n/Kids [");
 for (i=0; i<(page_pos+PARENT-1)/PARENT; i++) 
     {out_dec(parent[i]); out_string(" 0 R ");}
 out_string("]\n>>\nendobj\n");

 for (i=0; i<page_pos; i++)
   {if (!(i%PARENT)) 
       {obj_pos=parent[i/PARENT];
        out_obj_head("<<\n/Type /Pages\n/Parent 3 0 R\n/Count ");
        if ((j=page_pos-i)>PARENT) out_dec(PARENT); else out_dec(j);
        out_string("\n/Kids [");
       }
    out_dec(page[i]); out_string(" 0 R ");
    if (!((i+1)%PARENT) || i== page_pos-1) out_string("]\n>>\nendobj\n");
   }

 obj_pos=4;
 out_obj_head("<<\n/Type /Action\n/S /GoTo\n/D [");
 out_dec(page[0]);
 out_string(" 0 R /Fit]\n>>\nendobj\n");

 out_obj("<<\n/PageLayout /OneColumn\n>>");

 out_obj("[/PDF /Text /ImageC]");

 out_obj("<<\n/Producer (MakePDF V0.07 alpha 08.03.99)\n>>");

 obj_pos=objsav;
}

/***********************************************************************/
int out_page()
{int i,j,k;
 if (page_pos >= max_page) ende(8,5);
 page[page_pos]=obj_pos;
 out_obj_head("<<\n/Type /Page\n/Parent ");
 out_dec(parent[(page_pos++)/PARENT]);
 out_string(" 0 R\n/Resources ");
 out_dec(obj_pos);
 out_string(" 0 R\n/MediaBox [0 0 ");
 out_dec(paper_x); out_string(" ");
 out_dec(paper_y); out_string("]\n/Contents "); /* A4 */
 out_dec(obj_pos-3);
 out_string(" 0 R\n");
 if (annot_onpage)
   {out_string ("/Annots [");
    j=obj_pos+1;
    for (i=0; i<annot_onpage; i++)
      {out_dec(j); out_string(" 0 R ");
       k=annot[first_annot_onpage+i];
       j++; if (para[k]==2) j=j+para[k+8];
      }
    out_string("]\n");
   }
 out_string(">>\nendobj\n");

 out_obj_head("<<\n/Font 8 0 R\n/ProcSet 6 0 R\n");
 for (i=0; i<max_pict; i++) if (pict_onpage[i]!=0) break;
 if (i<max_pict)
   {out_string("/XObject << ");
    for (j=i; j<max_pict; j++)
       {if (pict_onpage[j]!=0) 
           {out_string("/Im");
            out_dec(j);
            out_string(" ");
            out_dec(pict_onpage[j]);
            pict_onpage[j]=0;
            out_string(" 0 R ");
           }
       }
    out_string(">>\n");
   }
 out_string(">>\nendobj\n");

 if ( (obj_pos += annot_onpage+action_onpage) >= max_obj) ende(9,6);
}
/***********************************************************************/
int out_page_contents()
{int i;

 while ((i=get_byte())!=EOF)
 {switch (i)
  {case TXT_COMMAND_BEGIN: txt_command(); break;
   case PDF_COMMAND_BEGIN: pdf_command(); break;
   case CTR_COMMAND_BEGIN: ctr_command(); break;
   case '\f': exit_page(); return;
   case '\n': exit_string();
              enter_text();
              out_string("T*\n"); 
              if (++line_count >= line_max) {exit_page(); return;} 
              break;
   default  : enter_string();
              if (i=='(' || i==')' || i=='\\') out_byte('\\');
              out_byte(i);
  }
 }
 exit_page();
 pex_eof=1;
}

/***********************************************************************/
enter_page() {if (!inpage) {inpage=1; out_obj_head("<< /Length "); 
              out_dec(obj_pos); out_string(" 0 R >>\nstream\n"); 
              stream_start=pdf_pos; text_onpage=0; 
              first_annot_onpage=annot_pos; annot_onpage=0;
              action_onpage=0; line_count=0;}
             }

exit_page() {int i; 
             if (!inpage) enter_page();
             inpage=0; exit_text(); 
             i=pdf_pos-stream_start; out_string("endstream\nendobj\n"); 
             out_obj_head(""); out_dec(i); out_string("\nendobj\n");
            }

enter_text() {char *p; 
              enter_page(); 
              if (!intext) 
                 {intext=1; out_string("BT\n");
                  if (!text_onpage) 
                     {text_onpage=1; 
                      if (!inittext_done) 
                       {inittext_done=1; p=inittext;
                        put_string("/F1 12 Tf 25 ",&p);
                        put_dec(paper_y-31,&p);
                        put_string(" Td 12 TL\n",&p);
                       }
                      if (!line_max) line_max=(paper_y-50)/12;
                      p=inittext; while (*p) out_byte(*p++);
                     }
                 }
              }  

exit_text() {int i;
             exit_string(); if (intext) {intext=0; out_string("\nET\n");}
             for (i=0; i<pdfcmd_pos; i++) out_byte(pdfcmd[i]);
             pdfcmd_pos=0;
            }


enter_string() {enter_text(); if (!instring) {instring=1; out_string("(");}} 
exit_string() {if (instring) {instring=0; out_string(") Tj ");}}

/***********************************************************************/


int txt_command() 
{int i;
 exit_string(); enter_text(); 
 while ((i=get_byte())!=TXT_COMMAND_END) {if (i==EOF) ende(10,7); out_byte(i);}
 out_string("\n");
}

/***********************************************************************/

int pdf_command() 
{int i;
 enter_page();
 if (intext) 
    {while ((i=get_byte())!=PDF_COMMAND_END) 
           {if (i==EOF) ende(11,7); 
            if (pdfcmd_pos>=max_pdfcmd) ende(12,8);
            pdfcmd[pdfcmd_pos++]=i;
           }
     pdfcmd[pdfcmd_pos++]='\n';
    }
 else 
    {while ((i=get_byte())!=PDF_COMMAND_END) 
           {if (i==EOF) ende(13,7); out_byte(i);}
     out_string("\n");
    } 
}
/***********************************************************************/

int ctr_command() 
{int i,j,k; char c[max_string+5];
 while (get_string(c)!=CTR_COMMAND_END)
 {if (cmpstr(c,"jpg"))
   {if (inpage) ende(14,9);
    if ( (i=get_dec()) >max_pict) ende(15,10);
    pict[i]=obj_pos;
    out_obj_head("<< /Type /XObject /Subtype /Image /Name /Im"); out_dec(i);
    out_string(" /Width "); out_dec(get_dec());
    out_string(" /Height "); out_dec(get_dec());
    out_string("\n/BitsPerComponent 8 /ColorSpace /DeviceRGB /Length ");
    out_dec(obj_pos); out_string(" 0 R /Filter /DCTDecode >>\nstream\n");
    get_string(c); i=insert_file(c);
    out_string("\nendstream\nendobj\n");
    out_obj_head("");out_dec(i);out_string("\nendobj\n"); 
   }
  else if (cmpstr(c,"gif"))
   {if (inpage) ende(16,9);
    if ( (i=get_dec()) >max_pict) ende(17,10);
    pict[i]=obj_pos;
    out_obj_head("<< /Type /XObject /Subtype /Image /Name /Im"); out_dec(i);
    out_string(" /Width "); out_dec(get_dec());
    out_string(" /Height "); out_dec(get_dec());
    out_string("\n/BitsPerComponent 8  /Length ");
    out_dec(obj_pos); 
    out_string(" 0 R /Filter /LZWDecode /DecodeParms <</EarlyChange 0>>\n");
    out_string("/ColorSpace [/Indexed /DeviceRGB ");
    get_string(c); i=insert_gif(c);
    out_string("\nendstream\nendobj\n");
    out_obj_head("");out_dec(i);out_string("\nendobj\n"); 
   }

  else if (cmpstr(c,"sound"))
   {if (inpage) ende(18,9);
    if ( (i=get_dec()) >max_sound) ende(19,24);
    sound[i]=obj_pos;
    out_obj_head("<< /Type /Sound /R "); out_dec(get_dec());
    out_string(" /C "); out_dec(get_dec());
    out_string(" /B "); out_dec(get_dec());
    out_string(" /E /"); get_string(c); out_string(c); 
    out_string(" /Length "); out_dec(obj_pos);
    out_string(" 0 R >>\nstream\n");
    get_string(c); i=insert_file(c);
    out_string("\nendstream\nendobj\n");
    out_obj_head("");out_dec(i);out_string("\nendobj\n"); 
   }

  else if (cmpstr(c,"paper"))
   {if (inpage || page_pos) ende(20,22);
    paper_x=get_dec();
    paper_y=get_dec();
   }

  else if (cmpstr(c,"inittext"))
   {while ((i=get_byte())!=TXT_COMMAND_BEGIN) {if (i>255 || i<0) ende(21,11);}
    j=0;
    while ( (i=get_byte()) != TXT_COMMAND_END) 
      {if (j >= max_inittext) ende(22,12);
       inittext[j++]=i;
      }
    inittext[j++]='\n';
    inittext[j]=0;
    inittext_done=1;
   }

  else if (cmpstr(c,"lines")) {line_max=get_dec();}

  else if (cmpstr(c,"pict")) 
   {if ((i=get_dec()) >= max_pict) ende(23,10);
    if (!(j=pict[i])) ende(24,13);
    pict_onpage[i]=j;
   }

  else if (cmpstr(c,"outline")) 
   {
    if (outline_pos >= max_outline) ende(25,14);
    if ( (i=get_dec()) >= max_outline_level || i<=0) ende(26,27);
    while (i>1 && (outline_pos==0 || outline[outline_pos-1].level<i-1))
        {if (!outline_pos) outline[outline_pos].level=1;
            else outline[outline_pos].level=outline[outline_pos-1].level+1;
         outline[outline_pos].page=page_pos+1;
         outline[outline_pos++].text=text_pos;
         if (outline_pos >= max_outline) ende(27,14);
        }    
    outline[outline_pos].level=i; 
    outline[outline_pos].page=page_pos+1;
    outline[outline_pos++].text=text_pos;
    add_text();
   }

  else if (cmpstr(c,"text")) 
   {if (!inpage) ende(28,16);
    if (annot_pos >= max_annot) ende(29,17); annot_onpage++;
    annot[annot_pos++]=para_pos;
    para[para_pos++]=0;
    para[para_pos++]=obj_pos+2+annot_onpage+action_onpage;
    para[para_pos++]=get_dec();
    para[para_pos++]=get_dec();
    para[para_pos  ]=para[para_pos-2]+get_dec(); para_pos++;
    para[para_pos  ]=para[para_pos-2]+get_dec(); para_pos++;
    para[para_pos++]=text_pos;
    add_text();
    if (para_pos>=max_para) ende(30,25);
   }

  else if (cmpstr(c,"link")) 
   {if (!inpage) ende(31,16);
    if (annot_pos >= max_annot) ende(32,17); annot_onpage++;
    annot[annot_pos++]=para_pos;
    para[para_pos++]=1;
    para[para_pos++]=obj_pos+2+annot_onpage+action_onpage;
    para[para_pos++]=get_dec();
    para[para_pos++]=get_dec();
    para[para_pos  ]=para[para_pos-2]+get_dec(); para_pos++;
    para[para_pos  ]=para[para_pos-2]+get_dec(); para_pos++;
    para[para_pos++]=get_dec();
    if ( (para[para_pos++]=get_dec() ) >= max_page) ende(33,5);
    if (para_pos>=max_para) ende(34,25);
   }

  else if (cmpstr(c,"action")) 
   {if (!inpage) ende(35,16);
    if (annot_pos >= max_annot) ende(36,17); annot_onpage++;
    annot[annot_pos++]=para_pos;
    para[para_pos++]=2;
    para[para_pos++]=obj_pos+2+annot_onpage+action_onpage;
    para[para_pos++]=get_dec();
    para[para_pos++]=get_dec();
    para[para_pos  ]=para[para_pos-2]+get_dec(); para_pos++;
    para[para_pos  ]=para[para_pos-2]+get_dec(); para_pos++;
    para[para_pos++]=get_dec();
    para[para_pos++]=text_pos;
    k=para_pos++;

    while ((i=get_byte())!=CTR_COMMAND_BEGIN) {if (i>255 || i<0) ende(37,11);}
    
    j=0;
    do {if ( (i=get_string(c)) && i!=CTR_COMMAND_END ) ende(38,11);
        if (cmpstr(c,"url"))
          {j++; action_onpage++;
           para[para_pos++]=1;
           if (get_string(c)) ende(39,11);
           add_string(c);
          }
        else if (cmpstr(c,"exec"))
          {j++; action_onpage++;
           para[para_pos++]=2;
           if (get_string(c)) ende(40,11);
           add_string(c);
           add_text();
          }
        else if (cmpstr(c,"sound"))
          {j++; action_onpage++;
           para[para_pos++]=3;
           para[para_pos++]=get_dec();
          }
        else if (cmpstr(c,"goto"))
          {j++; action_onpage++;
           para[para_pos++]=4;
           para[para_pos++]=get_dec();
           para[para_pos++]=get_dec();
           para[para_pos++]=get_dec();
           para[para_pos  ]=para[para_pos-2]+get_dec(); para_pos++;
           para[para_pos  ]=para[para_pos-2]+get_dec(); para_pos++;
          }
        else if (cmpstr(c,"first"))
          {j++; action_onpage++;
           para[para_pos++]=5;
          }
        else if (cmpstr(c,"prev"))
          {j++; action_onpage++;
           para[para_pos++]=6;
          }
        else if (cmpstr(c,"next"))
          {j++; action_onpage++;
           para[para_pos++]=7;
          }
        else if (cmpstr(c,"last"))
          {j++; action_onpage++;
           para[para_pos++]=8;
          }
        else if (cmpstr(c,"back"))
          {j++; action_onpage++;
           para[para_pos++]=9;
          }
        else if (cmpstr(c,"forward"))
          {j++; action_onpage++;
           para[para_pos++]=10;
          }
        else if (!cmpstr(c,"")) ende(41,26);
       }
    while (i != CTR_COMMAND_END);
    if (para_pos>=max_para) ende(42,25);
    if (!j) ende(43,23);
    para[k]=j;
   }
  else {print_string(c); ende(44,18);}
 }
}


int add_text()
{int i;
 while ((i=get_byte())!=TXT_COMMAND_BEGIN) {if (i>255 || i<0) ende(45,11);}
 while ( (i=get_byte()) != TXT_COMMAND_END) 
   {if (text_pos >= max_text) ende(46,15);
    if (i=='\\' || i=='(' || i==')') text[text_pos++]='\\';
    text[text_pos++]=i;
   }
 text[text_pos++]=0;
}

int add_string(p) char *p;
{while (*p)
 {if (text_pos >= max_text) ende(47,15);
  if (*p=='\\' || *p=='(' || *p==')') text[text_pos++]='\\';
  text[text_pos++]=*p++;
 }
 text[text_pos++]=0;
}

/***********************************************************************/
int out_obj_head(p) char *p;
{if (obj_pos>=max_obj) ende(48,6);
 obj[obj_pos]=pdf_pos;
 out_dec(obj_pos++);
 out_string(" 0 obj\n");
 out_string(p);
}
/***********************************************************************/
int out_obj(p) char *p;
{out_obj_head(p);
 out_string("\nendobj\n");
}
/***********************************************************************/
int insert_file(p) char *p;
{FILE *tmp; int i,j;
 tmp = fopen(p,"rb");  if (tmp==NULL) ende(49,19);
 j=pdf_pos;
 while ( (i=getc(tmp)) != EOF) out_bbyte(i);
 fclose(tmp);
 return(pdf_pos-j);
}
/***********************************************************************/

int insert_gif(p) char *p;
{FILE *tmp; int i,j,k;
 int rest=0, codelang=9, tablang=257;
 int posin=0, posout=23, incount=0, outcount=0, datout=0, datin;
 int getnext()
     {if (rest<0) return 0;
      if (!rest) rest=getc(tmp);
      if (!rest) {rest--; return 0;}
      rest--; incount++;
      return (getc(tmp));
     }
     
 tmp = fopen(p,"rb");  if (tmp==NULL) ende(50,19);
 if (getc(tmp)!='G'||getc(tmp)!='I'||getc(tmp)!='F') ende(51,28);
 for (i=0;i<8;i++) j=getc(tmp); /* ignore version, screen width+height */
 if (! (j&128)) ende(52,28);   /* exit if no global color table */
 j= (1<<((j&7)+1));             /* length of global color table */
 out_dec(j-1); out_string(" (");
 getc(tmp); getc(tmp);  /* ignore background color and pixel ratio */
 for (i=0; i<3*j; i++)  /* copy global color table */
   {k=getc(tmp); if (k=='\\'||k==')'||k=='(') out_bbyte('\\'); out_bbyte(k);}
 out_string(")]>>\nstream\n");
 
 if (getc(tmp) != 0x2c) ende(53,28); /* only simple gif files with image
                                          immediate following global color
                                          table are supported */ 
 for (i=0; i<8; i++) getc(tmp);      /* ignore position and size */
 if (getc(tmp)&0xc0) ende(54,28);  /* no local color table or interlaced */
 if (getc(tmp) != 8) ende(55,28);  /* LZW inital code size must be 9
                                        -> only 256 color gif */
 j=pdf_pos;
 /* datin=getnext(tmp)+ (getnext(tmp)<<8) +(getnext(tmp)<<16); */
 datin = getnext(); datin += (getnext()<<8); datin += (getnext()<<16);
 while (outcount<incount) 
    {tablang++;
     i=(datin>>posin)&((1<<codelang)-1);
     k=(posin+codelang)/8; posin=(posin+codelang)%8;
     while (k--) datin=(datin>>8)+(getnext()<<16);
     datout = datout + (i<<(posout-codelang+1));
     posout=posout-codelang;
     while (posout<16) {out_bbyte(datout>>16); outcount++;
                        datout=(datout&0xffff)<<8;
                        posout=posout+8;
                       }
     if ( i == 256 ) {tablang=257; codelang=9;}
     if ( i == 257 ) break;
     if (tablang == (1<<(codelang))) codelang++;
    }
 if (i!=257 || rest>0) ende(56,28);
 fclose(tmp);
 return(pdf_pos-j);
}

/***********************************************************************/
/***********************************************************************/
/***********************************************************************/

int getch() 
{int i;
 while ((i=getc(pex)) == 0x0d) ;
 if (i == '\n') line_nr++;
 return(i);
}

/***********************************************************************/
int getcha() 
{last_char=this_char; this_char=next_char; 
 if (in_ctr_cmd && (this_char=='*') && (last_char!='\\') )
    {while ((this_char=getch())!='*') if(this_char==EOF) ende(57,7); 
     this_char=getch(); 
    }
 next_char=getch();
 return(this_char);}

/***********************************************************************/

int get_byte() 
{int i; 
 if ((next_char=='>') && (this_char!=' ')) {this_char=' '; return(' ');}
 
 i=getcha(); 
 if ( (i==' ' || i=='\n') && (!in_ctr_cmd) &&
      (next_char=='[' || next_char=='{' || next_char=='<')) i=getcha();

 if (i=='[')  return (TXT_COMMAND_BEGIN);
 if (i==']')  {if (next_char==' ' || next_char=='\n') getcha();
               return (TXT_COMMAND_END);}
 if (i=='{')  return (PDF_COMMAND_BEGIN);
 if (i=='}')  {if (next_char==' ' || next_char=='\n') getcha();
               return (PDF_COMMAND_END);}
 if (i=='<')  {in_ctr_cmd=1; return (CTR_COMMAND_BEGIN);}
 if (i=='>')  {in_ctr_cmd=0; 
               if (next_char==' ' || next_char=='\n') getcha();
               return (CTR_COMMAND_END);}

 if (i=='\\') {i=getcha();
               if (i=='f') return('\f');
               if (i=='n') return('\n');
               if (i=='r') return('\r');
               if ((i<'0') || (i>'7')) return(i);
               i=i-'0'; 
               if (next_char<'0' || next_char>'7') return(i);
               i=i*8+getcha()-'0'; 
               if (next_char<'0' || next_char>'7') return(i);
               i=i*8+getcha()-'0';
              }
 return(i);
} 

/***********************************************************************/

int get_string(p) char *p;
{int i,j=0;
 do {if ( (i=get_byte()) >= 256) {*p=0; return(i);}} while(i<=' ');
 while ( i > ' ')
   {if (i>= 256) {*p=0; return(i);}
    *p++=i; if (j++ >=max_string) ende(58,20);
    i=get_byte();
   }
 *p=0; return(0);
} 
/***********************************************************************/

int get_dec()
{int i,j=0;
 do {if ( (i=get_byte()) >= 256) {ende(59,21);}} while(i<=' ');
 while (i>' ')
   {if (i>= 256) ende(60,21);
    if ( i<'0' || i>'9') ende(61,21); j=j*10+i-'0';
    i=get_byte();
   }
 return(j);
} 

/***********************************************************************/

int out_string(p) char *p; {while (*p) out_byte(*p++);}
int out_text(n,p) int n; char *p; {while (n--) out_byte(*p++);}
int out_hex1(i)   int i; { static char hex[] = {'0','1','2','3','4','5',
                  '6','7','8','9','a','b','c','d','e','f'}; 
                  out_byte(hex[(i>>4)&15]); out_byte(hex[i&15]);}
int out_hex2(i)   int i; {out_hex1(i>>8); out_hex1(i&0xff);}
int out_hex4(i)   int i; {out_hex2(i>>16); out_hex2(i&0xffff);}
int out_dec(i)    int i; {int k,j=1; if (i<0) {out_byte('-'); i = -i;}
                  k=i; while (k /= 10) j *= 10; while (j) {k=i/j;
                  out_byte(k+'0'); i -= k*j; j /= 10;}}
int out_dec10(i)  int i; {int k,j=1; if (i<0) {out_byte('-'); i = -i;}
                  j=1000000000; while (j) {k=i/j;
                  out_byte(k+'0'); i -= k*j; j /= 10;}}

int out_byte(i)   int i; {if (i=='\n') {if (last_put==i) return;
                                        putc('\015',pdf); pdf_pos++;}
                          last_put=i; putc(i,pdf); pdf_pos++;}
int out_bbyte(i)   int i; {last_put=0; putc(i,pdf); pdf_pos++;}

/***********************************************************************/

int cmpstr(p,q) char *p,*q;
{int i;
 do {if (*p != *q++) return(0);} while (*p++);
 return(1);
} 

int put_string(p,q) char *p,**q; 
    {while (*p) *(*q)++ = *p++; *(*q) =0;}

int put_dec(i,q) int i; char **q;
    {int k,j=1; 
     if (i<0) {*(*q)++ = '-'; i = -i;}
     k=i; 
     while (k /= 10) j *= 10; 
     while (j) {k=i/j; *(*q)++ = k+'0'; i -= k*j; j /= 10;}
     *(*q) =0;
    }

/***********************************************************************/
 
/***********************************************************************/

int ende(j,i) int j,i;

{char *p;
 static char *(meld[]) = {

/*  0 */ "no errors" ,
/*  1 */ "usage: makepdf infile outfile" ,
/*  2 */ "can't open input file" ,
/*  3 */ "can't open output file" ,
/*  4 */ "bad page number" ,
/*  5 */ "too many pages (increase max_page)" ,
/*  6 */ "too many objects (increase max_obj)" ,
/*  7 */ "unexpected end of input file" ,
/*  8 */ "too many pdf commands (increase max_pdfcmd)" ,
/*  9 */ "jpg or sound command not allowed if in page" ,
/* 10 */ "too many pictures (increase max_pict)" ,
/* 11 */ "error in string" ,
/* 12 */ "inittext to long (increase max_inittext)" ,
/* 13 */ "picture must be read in before output" ,
/* 14 */ "to many outlines (increase max_outline)" ,
/* 15 */ "text buffer too small (increase max_text)" ,
/* 16 */ "text/link/action annontation only if in page" ,
/* 17 */ "too many annotations (increase max_annot)" ,
/* 18 */ "unknown ctrl command" ,
/* 19 */ "can't open external file" ,
/* 20 */ "string to long (increase max_sting)" ,
/* 21 */ "error reading number" ,
/* 22 */ "paper command only before any text output" ,
/* 23 */ "no action in annotation" ,
/* 24 */ "to many sounds (increase max_sound)" ,
/* 25 */ "to many parameters (increase max_para)" ,
/* 26 */ "unknown action command" ,
/* 27 */ "to many outline levels (increas max_outline_level)" ,
/* 28 */ "gif file not found or unsupported format (only 256 colors!)" ,
/* 29 */ "you never should read this" ,
/* 30 */ "you never should read this" ,
};
 print_string("\n"); 
 if (i) {print_string("error in line "); print_dec(line_nr); 
         print_string(" ("); print_dec(j); print_string(")  ");}
 print_string(meld[i]); print_string("\n");
   
 if (pex!=NULL) fclose(pex);
 if (pdf!=NULL && pdf!=stdout) fclose(pdf); 
 exit(0);
}

/***********************************************************************/

int print_dec(i) int i;
{int k,j=1;
 if (i<0) {putc('-',stdout); i = -i;}
 k=i;
 while (k /= 10) j *= 10;
 while (j)
     {k=i/j;
      putc(k+'0',stdout);
      i -= k*j;
      j /= 10;
     }
}

/***********************************************************************/

int print_string(p) char *p;
{while (*p) putc(*p++,stdout);}

/***********************************************************************/


